> ## Documentation Index
> Fetch the complete documentation index at: https://docs2.finverse.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List bills

> List bills



## OpenAPI

````yaml /api-reference/openapi.json get /bills
openapi: 3.0.0
info:
  description: Documentation of the early finverse services
  title: Finverse Public
  termsOfService: https://example.com
  contact:
    name: Maintainers
    email: info@finverse.com
  license:
    name: unknown license
  version: 0.0.1
servers:
  - url: https://api.prod.finverse.net
security:
  - Oauth2:
      - test
tags:
  - name: public
    description: Publicly accessible endpoints
    x-group: Public
  - name: customer
    description: Customer app and institution endpoints
    x-group: Customer
  - name: link
    description: Finverse Link flows
    x-group: Link
  - name: login_identity
    description: Login identity lifecycle and metadata
    x-group: Login identity
  - name: accounts
    description: Accounts, balances, and account numbers
    x-group: Accounts
  - name: statements
    description: Statements and composite statements
    x-group: Statements
  - name: transactions
    description: Transaction history
    x-group: Transactions
  - name: identity_income
    description: Identity and income insights
    x-group: Identity & income
  - name: payment_links
    description: Payment link creation and checkout
    x-group: Payment links
  - name: mandates
    description: Direct debit mandates
    x-group: Mandates
  - name: payments
    description: Payment initiation and status
    x-group: Payment operations
  - name: payouts
    description: Payouts and scheduled payouts
    x-group: Payouts
  - name: payment_users
    description: Payment user profiles
    x-group: Payment users
  - name: payment_accounts
    description: Payment accounts for users
    x-group: Payment accounts
  - name: payment_methods
    description: Stored payment methods
    x-group: Payment methods
  - name: bills
    description: Bill presentment
    x-group: Bills
  - name: disputes
    description: Payment disputes
    x-group: Disputes
  - name: ledger
    description: Ledger and statements
    x-group: Ledger
paths:
  /bills:
    get:
      tags:
        - bills
      summary: List bills
      description: List bills
      operationId: listBills
      parameters:
        - description: ISO format (YYYY-MM-DD)
          name: date_from
          in: query
          schema:
            type: string
            format: date
        - description: ISO format (YYYY-MM-DD)
          name: date_to
          in: query
          schema:
            type: string
            format: date
        - description: Bill statuses to filter for, comma separated
          name: statuses
          in: query
          style: form
          explode: false
          schema:
            type: array
            items:
              type: string
              enum:
                - UNKNOWN
                - UNPAID
                - PAID
                - CANCELLED
                - FAILED
        - name: user_id
          in: query
          schema:
            type: string
        - name: external_user_id
          in: query
          schema:
            type: string
        - name: currencies
          in: query
          style: form
          explode: false
          schema:
            type: array
            items:
              type: string
        - description: default is 0
          name: offset
          in: query
          schema:
            type: integer
            default: 0
        - description: default is 500, max is 1000
          name: limit
          in: query
          schema:
            type: integer
            minimum: 1
            maximum: 1000
            default: 500
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ListBillsResponse'
        '400':
          description: Invalid Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrBodyModelV2'
      security:
        - Oauth2:
            - bill:list
components:
  schemas:
    ListBillsResponse:
      required:
        - bills
        - has_more
      properties:
        bills:
          type: array
          items:
            $ref: '#/components/schemas/FVBill'
        has_more:
          description: Whether additional bills exist beyond this page for the same query.
          type: boolean
    ErrBodyModelV2:
      properties:
        error:
          $ref: '#/components/schemas/FvErrorModelV2'
    FVBill:
      required:
        - bill_id
        - external_bill_id
        - user_id
        - external_user_id
        - customer_app_id
        - bill_date
        - due_date
        - details
        - status
        - integration_id
        - sender_details
        - created_at
        - updated_at
        - is_finverse_autopay_eligible
        - integration_metadata
      properties:
        bill_date:
          type: string
          format: date-time
          nullable: true
        bill_id:
          type: string
        created_at:
          type: string
          format: date-time
          nullable: true
        customer_app_id:
          type: string
        details:
          $ref: '#/components/schemas/BillDetails'
        due_date:
          type: string
          format: date-time
          nullable: true
        external_bill_id:
          type: string
        external_user_id:
          type: string
        integration_id:
          type: string
        integration_metadata:
          $ref: '#/components/schemas/BillIntegrationMetadata'
        is_finverse_autopay_eligible:
          type: boolean
        metadata:
          type: object
          additionalProperties:
            type: string
        sender_details:
          $ref: '#/components/schemas/BillSenderDetails'
        status:
          type: string
          enum:
            - UNKNOWN
            - UNPAID
            - PAID
            - CANCELLED
            - FAILED
        updated_at:
          type: string
          format: date-time
          nullable: true
        user_id:
          type: string
    FvErrorModelV2:
      required:
        - type
        - error_code
        - message
        - details
        - request_id
      properties:
        details:
          type: string
        error_code:
          type: string
          example: CREDENTIALS_INVALID
        message:
          type: string
        request_id:
          description: The request_id provided in the request header
          type: string
        type:
          description: The error type
          type: string
          enum:
            - LINK_ERROR
            - API_ERROR
          example: LINKING_ERROR
    BillDetails:
      required:
        - total_amount_due
        - currency
        - bill_reference_id
      properties:
        bill_reference_id:
          type: string
        currency:
          type: string
        description:
          type: string
        total_amount_due:
          type: integer
          format: int64
    BillIntegrationMetadata:
      required:
        - integration_id
      properties:
        integration_id:
          type: string
        rapidstor_metadata:
          $ref: '#/components/schemas/BillRapidstorMetadata'
    BillSenderDetails:
      required:
        - name
      properties:
        name:
          type: string
    BillRapidstorMetadata:
      required:
        - corp_code
        - s_location_code
        - tenant_id
        - i_anniv_days
        - tenant_default_currency
        - s_unit_name
        - account_token
        - ledger_id
        - unit_id
        - i_lease_num
        - d_sched_out
        - unit_type_id
      properties:
        account_token:
          type: string
        corp_code:
          type: string
        d_sched_out:
          type: string
        i_anniv_days:
          type: integer
          format: int64
        i_lease_num:
          type: string
        ledger_id:
          type: string
        s_location_code:
          type: string
        s_unit_name:
          type: string
        tenant_default_currency:
          type: string
        tenant_id:
          type: string
        unit_id:
          type: string
        unit_type_id:
          type: string
  securitySchemes:
    Oauth2:
      type: oauth2
      flows:
        clientCredentials:
          tokenUrl: https://finverse-dev.us.auth0.com/oauth/token
          scopes:
            account: Account
            balance: Balance
            credit: Credit
            institution: Institution
            investment: Investment
            link: Link
            test: Test
            transaction: Transaction

````